using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace treciZadatak
{
    class Program
    {
        static ulong RacunajX(ulong[] a)
        {
            ulong minRazlika = ulong.MaxValue;
            for (int i = 0; i < a.Length - 1; i++)
            {
                ulong razlika = a[i + 1] - a[i];
                if (razlika < minRazlika)
                {
                    minRazlika = razlika;
                }
            }

            return minRazlika;
        }
        static void Main(string[] args)
        {
            int t = int.Parse(Console.ReadLine());

            int[] rezultati = new int[t];

            for (int i = 0; i < t; i++)
            {
                string[] s = Console.ReadLine().Split();

                int n = int.Parse(s[0]);
                int m = int.Parse(s[1]);

                ulong[] a = new ulong[n];
                ulong[] b = new ulong[m];

                s = Console.ReadLine().Split();
                for (int j = 0; j < n; j++)
                {
                    a[j] = ulong.Parse(s[j]);
                }

                s = Console.ReadLine().Split();
                for (int j = 0; j < m; j++)
                {
                    b[j] = ulong.Parse(s[j]);
                }

                Array.Sort(a);
                Array.Sort(b);

                ulong x = RacunajX(a);

                int rezultat = 1;
                for (int j = 0; j < n - 1; j++)
                {
                    if ((a[j + 1] - a[j]) % x != 0)
                    {
                        rezultat = 0;
                        break;
                    }
                }

                if (rezultat == 1)
                {
                    ulong prviOblik = a[0] % x;
                    ulong drugiOblik = b[0] % x;

                    if (prviOblik == drugiOblik)
                    {
                        rezultat = 0;
                    }
                }

                rezultati[i] = rezultat;
            }

            for (int i = 0; i < t; i++)
            {
                Console.WriteLine(rezultati[i]);
            }
        }
    }
}